﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Shapes;
using System.Windows.Media;
using System.Windows.Controls;

namespace _2012_04_10_17_24_Praktikum_Loesung
{
    class Car
    {
        // besser: public double Position { get; private set; }
        public double Position;
        public double Speed;

        const double minimumDistance = 0.02;

        public Car(double position, double speed)
        {
            Position = position;
            Speed = speed;
        }

        public void Drive(double timeStep, Car[] cars)
        {
            // Noch ein verstecktes Problem: Wenn man sehr schnell fährt,
            // kann man quasi über Autos vor einem hüpfen.
            Position += timeStep * Speed;

            for (int i = 0; i < cars.Length; i++) // besser: foreach
            {
                if (cars[i] != this)
                {
                    if(FollowsTooClose(cars[i]))
                    {
                        Position = cars[i].Position + minimumDistance;
                    }
                }
            }
        }

        public void Draw(Canvas c, double size)
        {
            System.Windows.Shapes.Ellipse ellipse = new Ellipse();
            ellipse.Width = 6.0;
            ellipse.Height = 6.0;
            ellipse.Fill = Brushes.Red;
            c.Children.Add(ellipse);
            Canvas.SetLeft(ellipse, 0.5 * size * (1.0 + Math.Cos(2.0 * Math.PI * Position)) - 3.0 + 20.0);
            Canvas.SetTop(ellipse, 0.5 * size * (1.0 + Math.Sin(2.0 * Math.PI * Position)) - 3.0 + 20.0);
        }

        public bool FollowsTooClose(Car other)
        {
            double d = Position - other.Position;
            d -= Math.Floor(d); // Differenz der Anzahl der Runden ist egal.
            return d < minimumDistance;
        }
    }
}
